#!/usr/bin/env bash

# Copyright 2024 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the 'License');
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an 'AS IS' BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#common settings
if [[ -z "$1" ]]; then
    VERSION=latest
else
    VERSION=$1
fi
echo VERSION $VERSION
echo PROJECT_ID $PROJECT_ID ENVIRONMENT $ENVIRONMENT

ARTIFACT_REGISTRY=europe-docker.pkg.dev
AUTHEN_MODE=--no-allow-unauthenticated
CONCURRENCY=80
CPU=1
INGRESS=internal
# LOG_ONLY_SEVERITY_LEVELS=INFO_WARNING_NOTICE_CRITICAL
LOG_ONLY_SEVERITY_LEVELS=WARNING_NOTICE_CRITICAL
MAX_INSTANCES=1000
MEMORY=128Mi
PROJECT_ID_GAR=brunore-ram-dev-100
REGION=europe-west1
REPOSITORY_NAME=realtime-asset-monitor
TIMEOUT=--timeout=180s

gcloud config set project $PROJECT_ID

# Initial deployment done by terraform. so it is always possible to deploy no traffic
function deploy_crun (){
    echo $ENV_VARS
    gcloud run deploy ${SERVICE_NAME} \
        --no-traffic \
        --image=${ARTIFACT_REGISTRY}/${PROJECT_ID_GAR}/${REPOSITORY_NAME}/${IMAGE_NAME}:${VERSION} \
        --tag=${VERSION} \
        --region=${REGION} \
        ${AUTHEN_MODE} \
        --ingress=${INGRESS} \
        --concurrency=${CONCURRENCY} \
        --cpu=${CPU} \
        --memory=${MEMORY} \
        --max-instances=${MAX_INSTANCES} \
        ${TIMEOUT} \
        --service-account=${SERVICE_NAME}@${PROJECT_ID}.iam.gserviceaccount.com \
        --set-env-vars=${ENV_VARS} \
        --project=${PROJECT_ID}
}

SERVICE_NAME=launch
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=10
CONCURRENCY=80
MEMORY=128Mi
CPU=1
TIMEOUT=--timeout=180s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=executecaiexport
IMAGE_NAME=execute
MAX_INSTANCES=10
CONCURRENCY=80
MEMORY=128Mi
CPU=1
TIMEOUT=--timeout=180s
SERVICE_NAME_UP=${IMAGE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS},${SERVICE_NAME_UP}_ACTION_KIND=caiexport"
deploy_crun

SERVICE_NAME=splitexport
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=1000
CONCURRENCY=60
MEMORY=1Gi
CPU=1
TIMEOUT=--timeout=3600s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=convertfeed
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=1000
CONCURRENCY=200
MEMORY=128Mi
CPU=2
TIMEOUT=--timeout=180s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=fetchrules
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=300
CONCURRENCY=1000
MEMORY=256Mi
CPU=1
TIMEOUT=--timeout=1800s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=monitor
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=200
CONCURRENCY=200
MEMORY=256Mi
CPU=2
TIMEOUT=--timeout=900s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=stream2bq
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=300
CONCURRENCY=200
MEMORY=256Mi
CPU=2
TIMEOUT=--timeout=900s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=publish2fs
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=100
CONCURRENCY=200
MEMORY=128Mi
CPU=1
TIMEOUT=--timeout=180s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun

SERVICE_NAME=executegfsdeleteolddocs
IMAGE_NAME=execute
MAX_INSTANCES=10
CONCURRENCY=80
MEMORY=128Mi
CPU=1
TIMEOUT=--timeout=3600s
SERVICE_NAME_UP=${IMAGE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS},${SERVICE_NAME_UP}_ACTION_KIND=gfsdeleteolddocs"
deploy_crun

SERVICE_NAME=upload2gcs
IMAGE_NAME=${SERVICE_NAME}
MAX_INSTANCES=100
CONCURRENCY=12
MEMORY=512Mi
CPU=1
TIMEOUT=--timeout=180s
SERVICE_NAME_UP=${SERVICE_NAME^^}
ENV_VARS="${SERVICE_NAME_UP}_ENVIRONMENT=${ENVIRONMENT},${SERVICE_NAME_UP}_PROJECT_ID=${PROJECT_ID},${SERVICE_NAME_UP}_LOG_ONLY_SEVERITY_LEVELS=${LOG_ONLY_SEVERITY_LEVELS}"
deploy_crun
